;   HC-12
;      WDT
;   3- ,   (2 )   
.device ATtiny2313
;4    (    UART)
;    12 (PB0)
.include "tn2313def.inc"
	
.def temp =r16
.def Razr0 = r17 ; 
.def Razr1 = r18
.def value = r19 ;  

;============  ============
rjmp RESET ;Reset Handle
.org WDTaddr
rjmp WDT_over ;WDT Interrupt Vector Address

;==========  ============

out_com:  ;   value  . 
	sbis UCSRA,UDRE ;   
	rjmp out_com
	out	UDR,value ;value!!!   temp
ret


; N   T ()  .  F () 
;N = TF/4; F= 4  
; T = 50 mc N= 50 000, $C3 50 = 195 80
.macro Delay65 ; 
ldi Razr1,@0 ;  N
ldi Razr0,@1;  N
R_sub: 
 subi Razr0,1 
 sbci Razr1,0
brcc R_sub
.endm

WDT_over: ;  Watchdog
 sbi PortD,6 ; 
 sbi PortD,5 ; 
 Delay65 195, 80 ; 50   4  
	ldi value,'D' ; D
	rcall out_com ;    
	ldi value,'A' ; A
	rcall out_com ; 
	ldi value,'T' ; T
	rcall out_com ; 
	ldi value,Low(273) ;.   273
	rcall out_com ; 
	ldi value,High(273) ;.   273
	rcall out_com ; 
	ldi value,';' ; ';',  
	rcall out_com ; 
 Delay65 195, 80 ; 50   4  
 cbi PortD,6 ; 
 cbi PortD,5 ; 
reti ;  WDT

Reset:
	ldi		temp,low(RAMEND)   ;     	
	out	SPL,temp ; tiny2313  SPL

	ldi temp,1<<ACD	 
	out ACSR,temp ;. . 
	
ldi temp,0b01100000 ; D  PB5, PB6  
out DDRD,temp

;=== UART
	ldi temp,25 ;9600  4  + U2X
	out	UBRRL,temp ;. 
	ldi temp,(1<<RXEN|1<<TXEN)
	out	UCSRB,temp ;. / 8

;====  Watchdog,  !
 wdr ; WDT
 ldi temp,(1<<WDCE)|(1<<WDE) ;   +  
 out WDTCR,temp
 ldi temp, (1<<WDIE)|(1<< WDP3)  ;  +  (WDP3:0 = 1000 =4 )
 out WDTCR,temp
	
ldi temp,(1<< SM1)|(1<<SE) ; Sleep,  Power Down
out MCUCR,temp

sei ; 
	
Gcykle: ;  
	sleep ;  
 rjmp Gcykle 







