/*по схеме HC-12_peredatchik.png
 Питание модуля включается ключом BS-170 на время передачи
 Подключайте модуль только после загрузки программы и подключения к отдельному адаптеру питания!!! 
*/

#define Ledpin 13
#define OnOffpin 5 //управление ключом питания (PortD5)
#define RX  8  // * Определяем вывод RX (TX на модуле)
#define TX  9  // * Определяем вывод TX (RX на модуле)

#include <SoftwareSerial.h> // Библиотека программного последовательного порта
SoftwareSerial Serialpr(RX,TX); // Программный последовательный порт

word value=0; //условное число до 4-х знаков

void setup() {
Serialpr.begin(9600);
pinMode(Ledpin,OUTPUT);
pinMode(OnOffpin,OUTPUT);
}

void loop() {
value = value+128; //увеличиваем в каждом цикле на 128
if (value>9999) value=0;
digitalWrite(OnOffpin,HIGH); //включаем
delay(50);
digitalWrite(Ledpin,HIGH);
Serialpr.print(lowByte(value));
Serialpr.print(highByte(value));
delay(50);
digitalWrite(Ledpin,LOW);
digitalWrite(OnOffpin,LOW); //выключаем
delay(4000);
}
