/*Проба приемника HC-12 с OLED-дисплеем*/

#define Ledpin 13
#define RX 2 // * Определяем вывод RX (TX на модуле)
#define TX 3 // * Определяем вывод TX (RX на модуле)

#include <SoftwareSerial.h> //библиотека программного последовательного порта
SoftwareSerial Serialpr(RX,TX);           

#include <LiquidCrystalRus_OLED.h>

// RS, E, DB4, DB5, DB6, DB7
LiquidCrystalRus OLED1(4, 5, 7, 8, 9, 10);

volatile byte i=0; //счетчик принятых байт
//boolean Flag = false; //флаг приема
byte arr[6] ; //
byte bb;
word value;
 
void setup() {
delay (500);
//для проверки:
  OLED1.begin(16,2); //16 символов 2 строки
  OLED1.setCursor(0,0); //верхняя строка, 0 позиция 
    OLED1.print("10:22"); //имитация вывода времени
  OLED1.setCursor(2,0); //верхняя строка, 3 позиция ":"
  OLED1.blink(); //мигаем двоеточием
  
  delay(5000);
  OLED1.clear();
//апаратный последовательный порт для контроля:  
  Serial.begin(9600);
//программный последовательный порт для приема:  
  Serialpr.begin(9600);
//LED для мигания:  
pinMode(Ledpin,OUTPUT);
}//end setup
  
void loop() {
    if (Serialpr.available()>0) { 
      i=0;
  while (Serialpr.available()){
  digitalWrite(Ledpin,HIGH);        // Пришло! Считываем и анализируем
  bb=Serialpr.read();
//обязательная задержка, иначе вылетаем из while:  
  delay(2);
//  Serial.println(bb); //для отладки
//  Serial.print(' '); //для отладки
  {arr[i]=bb; i++;}
  } //конец while
    
  if (bb==';') { //если последний символ - конец данных
  if ((arr[0]=='D')&&(arr[1]=='A')&&(arr[2]=='T')) //если первые три символа = "DAT"
    value=arr[4]*256+arr[3]; //то формируем двухбайтовое число
//    Serial.println(value); //для отладки
  OLED1.clear();
  OLED1.setCursor(0,0); //верхняя строка, нулевая позиция
  OLED1.print(value); //выводим на дисплей
    digitalWrite(Ledpin,LOW);
    } //конец if bb
   } //конец  if Serialpr.available
}

