;HC-12    OLED 1602 
;     
.device ATmega8
;   4 
.include "m8def.inc"                             

; :
;#define Blink ;    
#define Rus_table ;    ( OLED Winstar)
#define Zerosymb ;  0    

/*; LCD16x02   ATmega8
;  4 
.equ E =4 ;PD4 (6)
.equ RS = 3 ;PD3 (5)
DB4-DB7 PortC 0-3
PC0 (23) - DB4
PC1 (24) - DB5
PC2 (25) - DB6
PC3 (26) - DB7 
*/
.equ Led = 7 ;Led   PD7
       
 ; BCD-      
.equ	AtBCD0	=9		;address of ResL    Bin-Dec
.equ	AtBCD2	=10		;address of ResH
.def	ResH=r10 ;      !
.def	ResL	=r9
       
       
;.def temp	= r16 ;   -   LCD1602.prg
;.def	Razr0 = r17 ;  -   LCD1602.prg
;.def	Razr1= r18 ;  -   LCD1602.prg
;.def	Razr2 = r19 ;  -   LCD1602.prg
.def valueL = r20;
.def valueH = r21;
.def temp2	= r22 ; 


rjmp RESET ; Reset Handler

.include "LCD1602.prg"

LCD_clear:
ldi temp,0b00000001 
rcall LCD_command_4bit ; clear 
rcall Del_5ms 
Set_cursor 0,0 ;   0,0
ret

in_com:   ;   temp  . 
	sbis	UCSRA,RXC  ;   
	rjmp	in_com
	in	temp,UDR ;
ret 

RESET:
	ldi		temp,low(RAMEND)             
	out		SPL,temp
	ldi		temp,high(RAMEND)	; 
	out		SPH,temp

sbi  DDRD,Led ;. 7  

;=== UART
	ldi temp,25 ;9600
	out	UBRRL,temp ;. 
	ldi temp,(1<<RXEN|1<<TXEN)
	out	UCSRB,temp ;. / 8


rcall LCD_ini ;  :
rcall Symbol_degree ;  

;  :

Set_cursor 0,0 ;  0  0  (0-15)
ldi temp,'2' ;2
rcall LCD_data
ldi temp,'0' ;0
rcall LCD_data
ldi temp,':' ;:
rcall LCD_data
ldi temp,'4' ;0
rcall LCD_data
ldi temp,'1' ;0
rcall LCD_data
Set_cursor 0,9 ;  0  9  (0-15)
ldi temp,'-' ;1
rcall LCD_data
ldi temp,'1' ;2
rcall LCD_data
ldi temp,'2' ;1
rcall LCD_data
ldi temp,',' ;2
rcall LCD_data
ldi temp,'3' ;2
rcall LCD_data
ldi temp,$01 ;  
rcall LCD_data
ldi temp,'C' ;C
rcall LCD_data
;  -:
Set_cursor 1,0 ;  1  0  (0-15)
ldi temp,'0' 
rcall LCD_data
ldi temp,'5' 
rcall LCD_data
ldi temp,' ' ;
rcall LCD_data
ldi temp,$E4 ; 
rcall LCD_data
ldi temp,'e'  ; e
rcall LCD_data
ldi temp,$B3 ;   
rcall LCD_data
ldi temp,'p' ; p  
rcall LCD_data
ldi temp,'a'  ; a
rcall LCD_data
ldi temp,$BB ;  
rcall LCD_data
ldi temp,$C7 ;  
rcall LCD_data
ldi temp,' ' ;
rcall LCD_data
ldi temp,' ' ;
rcall LCD_data
ldi temp,'2' ;
rcall LCD_data
ldi temp,'0' ;
rcall LCD_data
ldi temp,'2' ;
rcall LCD_data
ldi temp,'0' ;
rcall LCD_data

	sbi PortD,Led
rcall Del_500ms ;     0,5 
rcall Del_500ms 
rcall Del_500ms 
rcall Del_500ms 
rcall LCD_clear ; 
	cbi PortD,Led ; Led


Gcykle:
	rcall in_com ;    temp
	cpi temp,'D'
	brne Gcykle ;  D,    
	rcall in_com ;    temp
	cpi temp,'A'
	brne Gcykle ;  A,    
	rcall in_com ;    temp
	cpi temp,'T'
	brne Gcykle ;  T,    
;   
	rcall in_com ;    temp
	mov valueL,temp ; . 
	rcall in_com ;    temp
	mov valueH,temp ; . 
	rcall in_com ;    temp
	cpi temp, ';' 
	brne Gcykle ;   ,    
	;  Led
	sbi PortD,Led
	;   valueH:valueL  BCD-    
	rcall bin2BCD10
	rcall unpack_bcd8 ;3 .   ResH:valueH:valueL
	Set_cursor 0,0 ;  0  0
mov temp,ResH ; 
subi temp,-$30
rcall LCD_data
mov temp,valueH ; 
subi temp,-$30
rcall LCD_data
mov temp,valueL ; 
subi temp,-$30
rcall LCD_data
	cbi PortD,Led ; Led

rjmp Gcykle

;*****************************************************************
; 10- hex  (0-999=03E7)   BCD 3 . 
; : hex value low=valueL hex value high = valueH 
; BCD value digits 1 and 0 ResL, digits 2 ResH

bin2BCD10: 
	ldi	temp2,16	;Init loop counter	
	clr	ResH		
	clr	ResL		
	clr	ZH		;clear ZH 
bBCDx_1:
	lsl	valueL		;shift input value
	rol	valueH		;through all bytes
	rol	ResL		;
	rol	ResH
	dec	temp2		;decrement loop counter
	brne	bBCDx_2		;if counter not zero
	ret			;   return
bBCDx_2:
	ldi	ZL,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:
	ld	temp,-Z	;get (Z) with pre-decrement
	subi	temp,-$03	;add 0x03
	sbrc	temp,3	;if bit 3 not clear
	st	Z,temp	;	store back
	ld	temp,Z	;get (Z)
	subi	temp,-$30	;add 0x30
	sbrc	temp,7	;if bit 7 not clear
	st	Z,temp	;	store back
	cpi	ZL,AtBCD0	;done all three?
	brne	bBCDx_3		;loop again if not
	rjmp	bBCDx_1		

unpack_bcd8:
; ResL
;BCD -  ResL,  - valueH:valueL 
	mov valueL,ResL
	andi valueL,0b00001111 ; 
	mov valueH,ResL
	andi valueH,0b11110000 ; 
	swap valueH ;   
ret


